
combine=function(n, chosn.ind) {
 k=length(chosn.ind)
 i=k
 endeff=0
 chosn.ind[i]=chosn.ind[i]+1;
 while (chosn.ind[i]>(n-endeff)){
   if (i==1) {
      chosn.ind=c() 
      return()
   } 
     i=i-1
     endeff=endeff+1
     chosn.ind[i]=chosn.ind[i]+1
     chosn.ind[(i+1):k]=chosn.ind[i]+c(1:(k-i))
 }
 new_chosn.ind=chosn.ind
}

combination=function(n,k) {
    ret=c()
    if(k<=0) stop
    else {
      a=1:k
      while (!is.null(a)) {
          ret=rbind(ret, a)
          a=combine(n, a)

      }
    }  
 ret
} 
 

pr.mod=function(bc,a, p1, p2, p3, noF) {
    b=bc[1]
    c=bc[2] 
    c.max=a*(a-1)/2
    tmp=p1^a*(1-p1)^(noF-a)*p2^b*(1-p2)^(a-b)*p3^c*(1-p3)^(c.max-c)
    nu.mod=choose(noF, a) * choose(a, b)* choose(c.max, c)
    ret=c(a, bc, nu.mod, tmp, tmp*nu.mod)
#    print(ret)
}


pr.mat = function(pp, noF, noRun=18) {
  p1=pp[1]
  p2=pp[2]
  p3=pp[3]
  tmp=c()
  a.bound.min=min(noRun-1,noF)
  for(a in 0:a.bound.min) {
      b.max=a
      c.max=choose(a,2)
      bc.max = noRun - a
      b.max=a
      c.max=choose(a,2)
      bc.max = noRun - a

      a1 = matrix( rep(0:b.max, c.max + 1), 
		c.max + 1, b.max + 1, byrow=T)
      a2 = matrix( rep(0:c.max, b.max + 1), 
		c.max  + 1, b.max  + 1)
      A = array(c(a1,a2), c(c.max + 1, b.max + 1, 2) )
      R=matrix(unlist(apply(A, c(1,2), pr.mod, a, p1, p2, p3, noF)),byrow=T, ncol=6)
#      print(R)
     tmp=rbind(tmp, R)
  }
  tmp
#  print(tmp)
}


plot.hist=function(prmat, noF=6, noRun=18) {
  pr.hist=prmat[,4]*prmat[,5]
  noeff=2*noF+noF*(noF-1)/2
  pr=numeric(noeff)
  for (i in 1:noeff) {
     pr[i]=sum(pr.hist[apply(prmat[,c(1,2,3)],1, sum)==i])
   }
  barplot(pr,ylim=c(0,.5))
}


pr.adj=function(prmat, noRun){
   ind=apply(prmat[,c(1,2,3)],1, sum) >= noRun
       pr.gamma=sum(prmat[ind,6])
       mod.gamma=sum(prmat[ind,4])
   if (any(ind)==TRUE)   adj=pr.gamma/mod.gamma   else adj=0

#   print(pr.gamma)
#   print(adj)

   pr=prmat[,5]
   ind2=apply(prmat[,c(1,2,3)],1, sum)==(noRun-1)
   pr[ind2]=pr[ind2]+adj
   pr[ind]=0
   pradj=cbind(prmat[,c(1:4)], pr) 
   list(pradj=pradj, adj=adj)
}


F.pr.mod=function(bc, a, a.min, b.min, c.min, c.max, adj, pp, noF, noRun) {
   p1=pp[1]
   p2=pp[2]
   p3=pp[3]
  b=bc[1]
    c=bc[2] 
   if (a + sum(bc) < (noRun-1)) {
         tmp=p1^a*(1-p1)^(noF-a)*p2^b*(1-p2)^(a-b)*p3^c*(1-p3)^(c.max-c)
         nu.mod = choose(noF-a.min, a-a.min) * choose(a-b.min, bc[1]-b.min) * choose(c.max-c.min, bc[2]-c.min)
         ret=c(a, bc, nu.mod, tmp, tmp*nu.mod)
   } else  if  (a + sum(bc) == (noRun-1)) {
              tmp=p1^a*(1-p1)^(noF-a)*p2^b*(1-p2)^(a-b)*p3^c*(1-p3)^(c.max-c)+adj
              nu.mod = choose(noF-a.min, a-a.min) * choose(a-b.min, bc[1]-b.min) * choose(c.max-c.min, bc[2]-c.min)
              ret=c(a, bc, nu.mod, tmp, tmp*nu.mod)
        }
      else
          ret=numeric(6)
   	
  ret
#print(ret)
}


adj.xi=function(abc, adj, pp, noF, noRun) {
  a.min=abc[1]
  b.min=abc[2]
  c.min=abc[3]
  a.bound.min=min(noRun-1,noF)
  tmp=0
  if (a.min<=noF) {

    for(a in a.min:a.bound.min) {
      b.max=a
      c.max=choose(a,2)
      bc.max = noRun - a
      b.max=a
      c.max=choose(a,2)
      bc.max = noRun - a

      a1 = matrix( rep(b.min:b.max, c.max - c.min + 1), 
		c.max - c.min + 1, b.max - b.min + 1, byrow=T)
      a2 = matrix( rep(c.min:c.max, b.max - b.min + 1), 
		c.max - c.min + 1, b.max - b.min + 1)
      A = array(c(a1,a2), c(c.max - c.min + 1, b.max - b.min + 1, 2) )
      R=apply(A, c(1,2), F.pr.mod, a, a.min, b.min, c.min, c.max, adj, pp, noF, noRun)
      tmp= tmp + sum(R[6,,])
     }
  } else {tmp=0}
  tmp
# print(tmp)
}



